#include <Servo.h> 
#include "Ultrasonic.h"
Ultrasonic hcsrup( 12, 13 );
Ultrasonic hcsrdn( 7, 8 );
Servo myservosml;
Servo myservobig;
int enablepin = 0;    
int motor1Pin1 = 1;   
int motor1Pin2 = 2;   
int motor2Pin1 = 4;
int motor2Pin2 = 3;

int grippin1 = 5;
int grippin2 = 6; 

int ledpin = 9;   

int objdistance;
int lup = 0;
int distance = 0;
int left=0;
int right=0;
int back=0;
int pos, t=1;

void setup() 
{
  // set the switch as an input:
  // set all the other pins you're using as outputs:
  pinMode(enablepin, OUTPUT);
  pinMode(motor1Pin1, OUTPUT);
  pinMode(motor1Pin2, OUTPUT);
  pinMode(motor2Pin1, OUTPUT);
  pinMode(motor2Pin2, OUTPUT);
  
  pinMode(grippin1, OUTPUT);
  pinMode(grippin2, OUTPUT);
  
  pinMode(ledpin, OUTPUT);
  
  myservosml.attach(11);
  myservobig.attach(10);

  digitalWrite(enablepin, HIGH);  
  myservosml.write(80);
  myservobig.write(85);
  move();
     
}


void loop() 
{
  if(lup==0)
 {
  distance = ( hcsrup.Ranging(CM) );
  if (distance>=18)
  {
   forward();
   objdistance = ( hcsrdn.Ranging(CM) )*t;
   if(objdistance <= 9&&objdistance >= 0)
   {
     stoppage();
   for(pos = 80; pos != 53; pos-=1)    
  {                                
    myservosml.write(pos);             
    delay(15);                      
  }      
  delay(2000);
   grip();
   for(pos = 53; pos != 80; pos+=1)    
  {                                
    myservosml.write(pos);             
    delay(15);                      
  }  
  forward();
  t = -1;
   }

 }
  else
  {
    {
       analogWrite(ledpin, 255);         
       stoppage();                                // in steps of 1 degree 
      for(pos = 85; pos != 180; pos += 1)  
    {                                  
      myservobig.write(pos);             
      delay(15);                       
    } 
    delay(1500);
      
  right=( hcsrup.Ranging(CM) );
  
      for(pos = 180; pos != 0; pos -= 1)  
    {                                  
      myservobig.write(pos);             
      delay(15);                       
    } 
    delay(1500);
  left=( hcsrup.Ranging(CM) );
    
    for(pos = 0; pos != 86; pos += 1)  
    {                                  
      myservobig.write(pos);             
      delay(15);                       
    }    
     
      if(left>=18&&right>=18)
     {
      spinleft();
      delay(2080);
      analogWrite(ledpin, 150);         
     }
      if(left<=18&&right>=18)
     {
      spinright();
      delay(2080);
      analogWrite(ledpin, 150);         
     }
     if(left>=18&&right<=18)
     {
      spinleft();
      delay(2080);
      analogWrite(ledpin, 150);         
     }
     if(left<=18&&right<=18) 
     {
      spinleft();
      delay(4295);
      analogWrite(ledpin, 150);         
      back=( hcsrup.Ranging(CM) );
      if(back<=18)
      {
        drop();
        stoppage();
        lup=1;
      }
            
     } 
    }
   } 
  }
  else
  {
    stoppage();
  }
}

void forward() 
{
  {
    digitalWrite(motor1Pin1, LOW);   // set pin 2 on L293D low
    digitalWrite(motor1Pin2, HIGH);  // set pin 7 on L293D high
    digitalWrite(motor2Pin1, LOW);   // set pin 2 on L293D low
    digitalWrite(motor2Pin2, HIGH);  // set pin 7 on L293D high
  } 
}
void spinright() 
{
  {
    digitalWrite(motor1Pin1, LOW);   // set pin 2 on L293D low
    digitalWrite(motor1Pin2, HIGH);  // set pin 7 on L293D high
    digitalWrite(motor2Pin1, HIGH);   // set pin 2 on L293D low
    digitalWrite(motor2Pin2, LOW);  // set pin 7 on L293D high
  } 
}  
  void spinleft() 
{
  {
    digitalWrite(motor1Pin2, LOW);   // set pin 2 on L293D low
    digitalWrite(motor1Pin1, HIGH);  // set pin 7 on L293D high
    digitalWrite(motor2Pin2, HIGH);   // set pin 2 on L293D low
    digitalWrite(motor2Pin1, LOW);  // set pin 7 on L293D high
  } 
 }
 
 void backward() 
 {
  {
    digitalWrite(motor1Pin1, HIGH);   // set pin 2 on L293D low
    digitalWrite(motor1Pin2, LOW);  // set pin 7 on L293D high
    digitalWrite(motor2Pin1, HIGH);   // set pin 2 on L293D low
    digitalWrite(motor2Pin2, LOW);  // set pin 7 on L293D high
  } 
 }
 void stoppage() 
 {
  {
    digitalWrite(motor1Pin1, LOW);   // set pin 2 on L293D low
    digitalWrite(motor1Pin2, LOW);  // set pin 7 on L293D high
    digitalWrite(motor2Pin1, LOW);   // set pin 2 on L293D low
    digitalWrite(motor2Pin2, LOW);  // set pin 7 on L293D high
  } 
 }
void move() 
{ 
  for(pos = 80; pos != 100; pos += 1)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservosml.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 15ms for the servo to reach the position 
  } 
  delay(500);
  for(pos = 85; pos != 175; pos+=1)     // goes from 180 degrees to 0 degrees 
  {                                
    myservobig.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 15ms for the servo to reach the position 
  }
  delay(1500);
   for(pos = 179; pos != 0; pos-=1)     // goes from 180 degrees to 0 degrees 
  {                                
    myservobig.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 15ms for the servo to reach the position 
  }  
  delay(1500);
    for(pos = 1; pos != 84; pos+=1)     // goes from 180 degrees to 0 degrees 
  {                                
    myservobig.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 15ms for the servo to reach the position 
  }
   for(pos = 100; pos != 80; pos-=1)     // goes from 180 degrees to 0 degrees 
  {                                
    myservosml.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(15);                       // waits 15ms for the servo to reach the position 
  }  
  delay(3000);                   
  }  
  

void drop()
{
 digitalWrite(grippin1, HIGH);
 digitalWrite(grippin2, LOW);
}

void grip()
{
 digitalWrite(grippin2, HIGH);
 digitalWrite(grippin1, LOW);
}
